import nlp from 'compromise';

import helpers from 'wink-helpers';

import './style.css';

const CHUNK_SIZE = 1024;
const PAGE_TIME = 100;

function scramble(words) {
  const w = words.map(o => o.text());
  return helpers.array.shuffle(w);
}



function make_fragments(verbs, nouns) {
  const fragments = [];
  let wc = 0;
  while( verbs.length > 0 && nouns.length > 0 ) {
    const v = verbs.pop();
    const n = nouns.pop();
    if( nouns.length > 0 && Math.random() > 0.5 ) {
      const n2 = nouns.pop();
      fragments.push(`${n} ${v} ${n2}`);
    } else{
      fragments.push(`${n} ${v}`);
    }
  }
  return fragments;
}

async function damned_fort() {
  const response = await fetch("./damned.txt");
  if( !response.ok ) {
    throw new Error(`Response failed: ${response.status}`)
  }
  const text = await response.text();

  let i = 0;
  return ( append ) => {
    const chunk = text.substring(i, i + CHUNK_SIZE);
    if( chunk ) {
      const div = document.getElementById("page");
      const doc = nlp(chunk);
      const v = scramble(doc.verbs());
      const n = scramble(doc.nouns());
      const fragments = make_fragments(n, v);
      const fdoc = nlp(fragments.join(' '));
      const wc = fdoc.terms().length;
      const hfrag = `<p>${fragments.join('<br />')}</p>`;
      if( append ) {
        div.innerHTML += hfrag;
      } else {
        div.innerHTML = hfrag;
      }
      i +=CHUNK_SIZE;
      return wc;
    } else {
      i = 0;
      return 0;
    }

  }
}



function recurse_make(target, makef) {
  const new_target = target - makef(true);
  if( new_target > 0 ) {
    document.getElementById("nWords").value = String(new_target);
    setTimeout(() => { recurse_make(new_target, makef) }, PAGE_TIME);
  }
}


async function main() {

  const next_ctrl = await damned_fort();
  const next = document.getElementById("nextPage");

  next.addEventListener("click", (e) => { next_ctrl(false); });
  next_ctrl(true);
  const makeLots = document.getElementById("makeLots");
  makeLots.addEventListener("click", (e) => {
    const nwords = Number(document.getElementById("nWords").value);
    if( ! isNaN(nwords) ) {
      recurse_make(nwords, next_ctrl);
    };
  });
}




main();